/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   ### File Specific:
   main-programmer: Thomas Fahrni
   co-programmer:
*/
#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_AI
#include "ai_swarm.h"
#include "debug.h"

void AISwarm::process(float dt)
{
	std::set<AIModule*>::iterator it;
	for (it= swarmMembers.begin(); it!= swarmMembers.end(); it++ )
		(*it)->process(dt);
}

void AISwarm::addAI(AIModule* aiModule)
{
	swarmMembers.insert(aiModule);
}

void AISwarm::removeAI(AIModule* aiModule)
{
	std::set<AIModule*>::iterator it=swarmMembers.find(aiModule);
	if(it==swarmMembers.end())return;
	delete (*it);
}

int AISwarm::getSwarmSize()
{
	return swarmMembers.size();
}
